<?php

namespace App\Middleware;

/**
 * Class Middleware
 * ========================================================================
 * This class allows you to specify global middleware that will run on
 * every request. Middleware is useful for stuff like authentication,
 * checking if the app should be offline for maintenance, setting CORS, logging
 * request, etc.
 *
 * Middleware basically wraps the core (requests, responses, etc) of the
 * application. Therefore, you have the option to run the middleware before
 * the request is processed or after the core of the application is ran.
 *
 * For examples on how to set when middleware runs, see examples below.
 * To run before request see: BeforeMiddleware
 * To run after request see: AfterMiddleware
 *
 * Remember, this will run on EVERY request. For middleware specific to
 * a route, see the file in /routes/api/middleware-test
 * @package App\Middleware
 */
class Middleware
{

    /**
     * Register middleware to run on every request and every route.
     * @var array|string[]
     */
    public array $global = [
//        \App\Middleware\BeforeMiddleware::class,
//        \App\Middleware\AfterMiddleware::class,
    ];

}