<?php

namespace App\Models;

use Doctrine\ORM\Mapping as ORM;
use Snaju\Inception\ORM\DataModel;

/**
 * @ORM\Entity
 * @ORM\Table(name="users")
 */
class User extends DataModel
{

    /**
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     * @ORM\Column(type="integer")
     */
    protected int $id;

    /**
     * @ORM\Column(type="string",nullable=true)
     */
    protected string $firstname;

    /**
     * @ORM\Column(type="string",nullable=true)
     */
    protected string $lastname;

    /**
     * @ORM\Column(type="string")
     */
    protected string $email;

    /**
     * @ORM\Column(type="string")
     */
    protected string $password;

    /**
     * @ORM\Column(type="string")
     */
    protected string $password_salt;

    /**
     * @ORM\Column(type="string",nullable=true)
     */
    protected string $avatar;

    /**
     * @ORM\Column(type="string",nullable=true)
     */
    protected string $pref_date_format;

    /**
     * @ORM\Column(type="string",nullable=true)
     */
    protected string $pref_time_format;

    /**
     * @ORM\Column(type="string",nullable=true)
     */
    protected string $pref_timezone;

    /**
     * @ORM\Column(type="string",nullable=true)
     */
    protected string $pref_theme;

    /**
     * @ORM\Column(type="datetime",nullable=true)
     */
    protected string $email_verified_at;

    /**
     * @ORM\Column(type="datetime",nullable=true)
     */
    protected string $onboarding_completed_at;

    /**
     * @ORM\Column(type="datetime",nullable=true)
     */
    protected string $created_at;

    /**
     * @ORM\Column(type="datetime",nullable=true)
     */
    protected string $updated_at;

}